"use strict";

var EditorState = require("./EditorState");

var getContentEditableContainer = require("./getContentEditableContainer");

var getDraftEditorSelection = require("./getDraftEditorSelection"); // 同步调用，防止editorState存在多个不同副本，导致数据丢失 -- deprecated  好像没啥用，不同步也没啥影响


var lockCall = function lockCall(uuid, func, sync, args) {
  func.apply(void 0, args);
};

var lockCall2 = function lockCall2(uuid, func, sync, args) {
  // 使用乐观锁 处理并发问题 -- 没必要 -- js单线程的，所以只需要简单同步下就行了
  window.dLock = window.dLock || {}; // let rand = Math.random();

  var deadCnt = window.lockDeadCnt || 1000;

  while (true) {
    if (deadCnt-- <= 0) {
      var _dLock$uuid;

      console.error("\u53EF\u80FD\u5B58\u5728\u6B7B\u9501,".concat(func.name, "\u7B49\u5F85").concat((_dLock$uuid = dLock[uuid]) === null || _dLock$uuid === void 0 ? void 0 : _dLock$uuid.name));
      break;
    }

    if (dLock[uuid] && dLock[uuid] != func) {
      continue;
    }

    dLock[uuid] = func; // console.log(func.name + '开始');

    func.apply(void 0, args);
    delete dLock[uuid]; // console.log(func.name + '结束');

    break;
  }
};

var spinDo = function spinDo(handler, interval, tryCnt) {
  interval = interval || 100;
  tryCnt = tryCnt || 20;
  var cnt = 0;
  var error0;
  var timer = setInterval(function () {
    var error;

    try {
      handler();
      clearInterval(timer);
    } catch (e) {
      // ignore
      cnt++;
      error = e;
      error0 = error0 || e;
    }

    if (cnt == tryCnt) {
      clearInterval(timer); // 首次和最后一次报错比较关键

      console.error('spinDo fail...', error0, error);
    }
  }, interval);
}; // 更新光标位置，更新editorState中的selectionState。


var updateSelection = function updateSelection(editor) {
  var editorState = editor._latestEditorState;
  var documentSelection = getDraftEditorSelection(editorState, getContentEditableContainer(editor));
  var updatedSelectionState = documentSelection.selectionState;
  editorState = EditorState.forceSelection(editorState, updatedSelectionState);
  editor.update(editorState);
};

module.exports = {
  lockCall: lockCall,
  spinDo: spinDo,
  updateSelection: updateSelection
};